#include <iostream>
#include <string>
using namespace std;


template<class T>
T summa(T m[], int kogus){
  T vastus=m[0];
  for(int i=1; i<kogus; i++){
    vastus=vastus+m[i];
  }
  return vastus;
}

class Arv{
  public:
  int a;
  Arv(int ua);
  Arv(const Arv& arv); 
  Arv operator+(Arv& arv);
};


Arv::Arv(int ua){
  a=ua;
}

Arv::Arv(const Arv& arv){
  a=arv.a;
}

Arv Arv::operator+(Arv& arv){
 return Arv(a+arv.a);
}


int main(void){
  int taisarvud[]={2, 4, 5};
  string tekstid[]={"Jaan", "Juss", "Juku"};
  Arv arvud[]={Arv(4), Arv(5), Arv(7)};
  int taisarvusumma=summa(taisarvud, 3);
  string tekstisumma=summa(tekstid, 3);
  Arv arvusumma=summa(arvud, 3);
  cout << taisarvusumma << " " << tekstisumma 
       << " " << arvusumma.a << endl;
  return 0;
}
