from Globals import InitializeClass, DTMLFile, Persistent
from OFS.SimpleItem import Item
from AccessControl.Role import RoleManager
from Acquisition import Implicit

def lisamisKonstruktor(lisaja):
  "Uus tervitaja"
  lisaja.Destination()._setObject("tere6", Tere6())
  return "Lisatud leht nimega tere6"
  


class Tere6(Implicit, RoleManager, Item, Persistent):
  "Psivate andmetega klass"
  meta_type="Tere6"
  loendur=0
  teade="Tere tulemast"
  manage_options=({'label': 'Muuda pealkirja', 'action':'teateHaldus'},)+\
    RoleManager.manage_options + Item.manage_options

  def index_html(self):
    "Vaikimisi meetod"
    self.loendur=self.loendur+1
    return ("Teate vaatamine", """<h2>%s</h2>Lehte on vaadatud %d korda.""" % (self.teade,self.loendur))
    
  def teateHaldus(self):
    "Teate haldamise leheklg"
    return ("Teate haldamine", """ 
      <form action='teateMuutus'>
        Teade:<input type='text' name='uusTeade' value='%s' />
      </form>
    """ % self.teade)
    
  def teateMuutus(self, REQUEST, uusTeade):
     "Teate muutmise leheklg"
     self.teade=uusTeade
     REQUEST.RESPONSE.redirect('teateHaldus')
    
InitializeClass(Tere6)